/*
 * eMySQLAdmin
 * create Database form
 * version prototype 0.1
 * author : AIT YAHIA Idir
 * created on march 20 2009
 * last edit on april 5 2009
 * (c) copyright dune-devzone 2009
 * */
 
 

/**
 * function for build create table SQL query.
 * 
 * @author AIT YAHIA IDIR
 * @param string name
 * @param string charset
 * @param string collate
 * @return string SQL Code
 */
function createDatabase(name, charset, collate) {
	sql = 'CREATE DATABASE `' + name + '`';
	if ((charset != '') && (charset != '')) {
		sql += '\n\tDEFAULT CHARACTER SET ' + charset + '\n\tCOLLATE '
				+ collate;
	}

	sql += ';';

	return sql;
}

var info_message; // front message witch showing for a user a result of
				  // query

/**
 * function seeding SQL query to server.
 * 
 * @author AIT YAHIA IDIR
 * @param string name
 * @param string charset
 * @param string collate
 * @return string SQL Code
 */
function sqlQuery(query) {
	Ext.Ajax.request({
		id : 'sql-query',
		url : 'index/sqlquery',
		methode : '',
		params : {
			gData : 'sqlquery',
			appId:AppId,
			query : query
		},
		success : function(response) {
			var queryResp = {};
			queryResp = Ext.util.JSON.decode(response.responseText);
			if (true == queryResp.success) {
				info_message = Ext.DomHelper.append(Ext.getBody(), {
							cls : 'x-success-message'
						}, true);
				info_message.update('votre requete a été correctement excuté');
				info_message.alignTo(bottomTlBar.getEl(), 'bl-tl?').fadeIn('b', {
							duration : .6,
							easing : 'easeOut'
						});

			} else {
				info_message = Ext.DomHelper.append(Ext.getBody(), {
							cls : 'x-fail-message'
						}, true);
				info_message
						.update(queryResp.errorMsg);
				info_message.alignTo(bottomTlBar.getEl(), 'bl-tl?').fadeIn('b', {
							duration : .6,
							easing : 'easeOut'
						});
			}

		},
		failure : function() {
			info_message = Ext.DomHelper.append(Ext.getBody(), {
						cls : 'x-fail-message'
					}, true);
			info_message.update(REQUEST_ACTION_FAILURE);
			info_message.alignTo(bottomTlBar.getEl(), 'bl-tl?').fadeIn('b', {
						duration : .6,
						easing : 'easeOut'
					});
		}

	})
}

/*
 * reset the value of combobox when we ckick delete or backspace key
 */
Ext.form.ComboBox.prototype.fireKeyOriginal = Ext.form.ComboBox.prototype.fireKey;
Ext.form.ComboBox.prototype.fireKey = function(e) {
	this.fireKeyOriginal(e);
	if ((e.getKey() == Ext.EventObject.DELETE)
			|| (e.getKey() == Ext.EventObject.BACKSPACE)) {
		this.clearValue();
	}
}

/*
 * Store for loading CHARSET from server.
 */
charSetDataStore = new Ext.data.Store({
			id : 'charSetDataStore',
			proxy : new Ext.data.HttpProxy({
						url : 'index/getdata',
						method : 'POST'

					}),
			baseParams : {
				gData : 'charset'
			},
			reader : new Ext.data.JsonReader({
						root : 'results',
						id : 'id'
					}, [{
								name : 'CHARACTER_SET_NAME',
								type : 'string',
								mapping : 'CHARACTER_SET_NAME'
							}, {
								name : 'DESCRIPTION',
								type : 'string',
								mapping : 'DESCRIPTION'
							}, {
								name : 'DEFAULT_COLLATE_NAME',
								type : 'string',
								mapping : 'DEFAULT_COLLATE_NAME'
							}

					]),

			sortInfo : {
				field : 'CHARACTER_SET_NAME',
				direction : "ASC"
			}

		});

/*
 * Store for loading COLLATE list for select charset from server.
 */
collateDataStore = new Ext.data.Store({
			id : 'collateDataStore',
			proxy : new Ext.data.HttpProxy({
						url : 'index/getdata',
						method : 'POST'

					}),
			baseParams : {
				gData : 'collate'

			},
			reader : new Ext.data.JsonReader({
						root : 'results',
						id : 'id'
					}, [{
								name : 'CHARACTER_SET_NAME',
								type : 'string',
								mapping : 'CHARACTER_SET_NAME'
							}, {
								name : 'COLLATION_NAME',
								type : 'string',
								mapping : 'COLLATION_NAME'
							}

					]),

			sortInfo : {
				field : 'COLLATION_NAME',
				direction : "ASC"
			}

		});

charSetDataStore.load();

/* 
 * Create database form panl content field
 * */

/*database name filed */
var databaseNameField = new Ext.form.TextField({
						fieldLabel : "Nom",
						id : 'nom',
						name : "nom",
						anchor : "97.5%",
						border : false,
						allowBlank : false,
						maskRe : /([a-zA-Z0-9\s-_&é#'çà+]+)$/});
						
/*comboBox that list suppoted charset*/						
var comboCharset =  new Ext.form.ComboBox({
	fieldLabel : "Charset",
						id : "id-charset",
						editable : true,
						name : "charset",
						allowBlank : true,
						store : charSetDataStore,
						forceSelection : true,
						emptyText : 'Selectioné le charset',
						mode : 'local',
						displayField : 'DESCRIPTION',
						valueField : 'CHARACTER_SET_NAME',
						typeAhead : true,

						triggerAction : 'all',
						listClass : 'x-combo-list-small',

						anchor : "95%",
						lastQuery : '',
						listeners : {
							select : {
								fn : function(combo, value) {

									var comboCollate = Ext.getCmp('id-collate');

									if (value.CHARACTER_SET_NAME != '') {
										comboCollate.enable();
										collateDataStore.load({
													params : {
														charset : combo
																.getValue()
													}
												});
										comboCollate.setValue(combo.store
												.getAt(combo.selectedIndex)
												.get('DEFAULT_COLLATE_NAME'));
									} else {
										comboCollate.clearValue();
										comboCollate.disable();

									}

								}
							},
							blur : {
								fn : function(combo) { // desactivate collate
														// combo on blur comb
														// charsaet if is null
									var comboCollate = Ext.getCmp('id-collate');
									if (combo.getValue() == '') {
										comboCollate.clearValue()
										comboCollate.disable();

									}
								}
							}

						}
});

/*comboBox that list a collate*/
var comboCollate =  new Ext.form.ComboBox({fieldLabel : "Collate",
						editable : false,
						name : "collate",
						id : "id-collate",
						hiddenName : "collate",
						store : collateDataStore,
						mode : 'local',
						displayField : 'COLLATION_NAME',
						valueField : 'COLLATION_NAME',
						typeAhead : true,
						triggerAction : 'all',
						listClass : 'x-combo-list-small',
						disabled : true,
						anchor : "95%"});
var newDataBasePanel = new Ext.FormPanel({
			id : 'newDataBasePanel',
			labelWidth : 55,
			baseCls : 'x-plain',
			bodyStyle : 'padding:5px;',
			labelWidth : 55,
			hidden : false,
			url : 'save-form.php',
			defaultType : 'textfield',
			items : [
			  		databaseNameField, 
					comboCharset,
					comboCollate]

		});

/*
 * Form Panel that showing a builded Query using Ext.ux.CodePress
 */
SQLPanel = new Ext.FormPanel({
			id : 'newDataBasePanel',
			layout : 'fit',
			items : [new Ext.ux.CodePress({
						id : 'new-DataBase-Editor',
						width : 500,
						height : 300,
						language : 'SQL'

					})]
		});
/*
 * Create database form botom tools bar
 * 
 */
bottomTlBar = new Ext.Toolbar({
	items : [{
				text : 'Compiler',
				xtype : 'button',
				id : 'new-dtabase-compile',
				tooltip : 'Enregistrer la fiche en cours',
				iconCls : 'compile-sql', // this is defined in our styles.css
				scope : this, 
				formBind : true,
				handler : function() {

					dataBaseName = Ext.getCmp('nom').getValue().trim();
					charset = Ext.getCmp('id-charset').getValue();
					collate = Ext.getCmp('id-collate').getValue();
					sql = createDatabase(dataBaseName, charset, collate);
					Ext.getCmp('new-DataBase-Editor').code = sql;
					Ext.getCmp('new-database-execute').show();
					Ext.getCmp('new-dtabase-compile').hide();

					newDataBasePanel.hide();
					newDataBase.add(SQLPanel);
					newDataBase.doLayout();

				}

			}, {
				text : 'Executer',
				xtype : 'button',
				hidden : true,
				id : 'new-database-execute',
				tooltip : 'Enregistrer la fiche en cours',
				iconCls : 'run-sql', // this is defined in our
				scope : this, // styles.css
				formBind : true,
				handler : function() {
					sql = Ext.getCmp('new-DataBase-Editor').code;
					sqlQuery(sql);
				}
			}, '-', {
				text : 'Annuler',
				xtype : 'button',

				id : 'cancel-new-databse',
				tooltip : 'Annuler l\'opération de création de base de données',
				iconCls : 'cancel-process', // this is defined in ourscope : this, styles.css
				formBind : true,
				handler : function() {
					newDataBase.destroy();

				}

			}]
});

/*
 * Create database main window
 */
var newDataBase = new Ext.Window({
			title : ADD_DATABASE_LABEL,
			id : 'newDataBase',
			width : 500,
			height : 300,
			frame : true,
			closable : true,
			layout : 'fit',
			bodyStyle : 'padding:5px;',
			items : newDataBasePanel,
			bbar : bottomTlBar,
			listeners : {
				move : {
					fn : function(wind, x, y) {
						info_message.alignTo(bottomTlBar.getEl(), 'bl-tl?')
								.fadeIn('b', {
											duration : .6,
											easing : 'easeOut'
										});

					}
				},
				destroy : {
					fn : function(wind) {
						Ext.destroy(info_message);

					}
				}
			}
		});