/*
 * Load the database tree
 * parameters void
 * @author AIT YAHIA Idir
 */
var dbBaseTree;
var baseTreeLoader;

/*
 * Menu items click handler
 */
function clickHandler() {
	Ext.MessageBox.alert('items clicked', 'itesm clicked');
}


/*
 * context menu database node
 */
var databaseContextMenu = new Ext.menu.Menu({
			id : 'databaseContextMenu',
			items : [{
						text : DROP_DATABASE_LABEL,
						handler : clickHandler,
						iconCls : 'drop-database'
					}, {
						text : ADD_TABLE_LABEL,
						handler : clickHandler,
						iconCls : 'add-table'
					}, new Ext.menu.Item({
								text : EXPORT_DATABASE_LABEL,
								handler : clickHandler
							}), '-', new Ext.menu.Item({
								text : REFRESH_LABEL,
								iconCls : 'refresh',
								checkHandler : clickHandler
							})

			]
		});

/*
 * context menu for table node
 */
var tableContextMenu = new Ext.menu.Menu({
			id : 'tableContextMenu',
			items : [{
						text : DROP_TABLE_LABEL,
						handler : clickHandler,
						iconCls : 'drop-table'
					}, {
						text : RENAME_TABLE_LABEL,
						handler : clickHandler,
						iconCls : 'rename'
					}, new Ext.menu.Item({
								text : EDIT_TABLE_LABEL,
								handler : clickHandler,
								iconCls : 'edit-table'
							}), '-', new Ext.menu.Item({
								text : ADD_LABEL,
								menu : [{
											text : FIELD_LABEL,
											handler : clickHandler,
											iconCls : 'add-field'
										}, new Ext.menu.Item({
													text : INDEX_LABEL,
													handler : clickHandler
												}), new Ext.menu.Item({
													text : FOREIGN_KEY,
													handler : clickHandler
												}), new Ext.menu.Item({
													text : TRIGGER_LABEL,
													handler : clickHandler
												})]
							}), '-', new Ext.menu.Item({
								text : REFRESH_LABEL,
								iconCls : 'refresh',
								checkHandler : clickHandler
							})

			]
		});

/*
 * database tree loder
 */

baseTreeLoader = new Ext.tree.TreeLoader({
			id : 'baseTreeLoader',
			url : 'index/getdata',
			method : 'POST',
			baseParams : {
				gData : 'getBaseTree',
				objectType : ''
			}
		});

/*
 * check witch node to load based on in here ObjectType 
 */
baseTreeLoader.on('beforeload', function(baseTreeLoader, node) {
			this.baseParams.objectType = node.attributes.objectType;
		}, baseTreeLoader);



/*
 * server database tree panel 
 * */
dbBaseTree = new Ext.tree.TreePanel({
			id : 'dbBaseTree',
			title : DATABASES,
			border : false,
			autoScroll : true,
			iconCls : 'rh_login',
			// tree-specific configs:
			rootVisible : false,
			lines : false,
			singleExpand : false,
			useArrows : true,

			loader : baseTreeLoader,
			root : new Ext.tree.AsyncTreeNode({
						id : 'localhost',
						objectType : 'root',
						iconCls : 'server'
					}),
			listeners : {
				contextmenu : function(node, e) {
					node.select();
					node.select();
					//var c = node.contextMenu;
					if (node.attributes.objectType == 'database') {
						databaseContextMenu.contextNode = node;
						databaseContextMenu.showAt(e.getXY());
					}
					if (node.attributes.objectType == 'table') {
						tableContextMenu.contextNode = node;
						tableContextMenu.showAt(e.getXY());
					}

				}
			}
		})
